/* FILE PROPTST1.C */

/* test for rcsc - retargetable concurrent smallc compiler */
/* use with PROPTOKEN.M4 to create Spin file               */

/* include standard defines and required variables */
/* remember: RCSC only has one level of include, nested includes are not supported */
/* remember: use dos 8.3 filenames only */
#include ".\rcsc_lib\_stdio.h"
#include "prop.h"

  /* first the global definitions */
  char ca[32];  /*  32 */
  int i,j;      /*   4 */
  int ia[10];   /*  20 */


  /* then the functions, including main */

/* as there is no commandline, main has no arguments */
main () {
  char k; int p, q, r[6];

  k='A';       /* for stack integrity check */
  test2(&p);   /* pass address of p, test2 makes p = 128 */
  q = test3(); /* test3 returns 4 */
  i=p;
  j=q;

  /* try all operators */
  ia[0] = i + j;  /*  132 */
  ia[1] = i - j;  /*  124 */
  ia[2] = i * j;  /*  512 */
  ia[3] = i / j;  /*   32 */
  ia[4] = i % j;  /*    0 */
  ia[5] = i ^ j;  /*  132 */
  ia[6] = i & j;  /*    0 */
  ia[7] = i | j;  /*  132 */
  ia[8] = i << j; /* 2048 */
  ia[9] = i >> j; /*    8 */

  j = 1;  /* 1 */
  j += 1; /* 2 */
  j -= 1; /* 1 */
  j *= 2; /* 2 */
  j /= 2; /* 1 */
  j %= 8; /* 1 */
  j ^= 7; /* 6 */
  j &= 3; /* 2 */
  j |= 1; /* 3 */

  /* M4 generates EOF in argument listing error when using array[constant] */
  /* workaround for now: assign constant to dummy local int                */
  i=10;
  if (i <  11) {ca[q=0]=1;}  /* 1 */
  if (i >  11) {ca[q=1]=1;}  /* 0 */
  if (i <= 11) {ca[q=2]=1;}  /* 1 */
  if (i >= 11) {ca[q=3]=1;}  /* 0 */
  if (i == 11) {ca[q=4]=1;}  /* 0 */
  if (i != 11) {ca[q=5]=1;}  /* 1 */
  i=11;
  if (i <  11) {ca[q=8]=1;}  /* 0 */
  if (i >  11) {ca[q=9]=1;}  /* 0 */
  if (i <= 11) {ca[q=10]=1;} /* 1 */
  if (i >= 11) {ca[q=11]=1;} /* 1 */
  if (i == 11) {ca[q=12]=1;} /* 1 */
  if (i != 11) {ca[q=13]=1;} /* 0 */
  i=12;
  if (i <  11) {ca[q=16]=1;} /* 0 */
  if (i >  11) {ca[q=17]=1;} /* 1 */
  if (i <= 11) {ca[q=18]=1;} /* 0 */
  if (i >= 11) {ca[q=19]=1;} /* 1 */
  if (i == 11) {ca[q=20]=1;} /* 0 */
  if (i != 11) {ca[q=21]=1;} /* 1 */
  i=-2;
  if (i <  0) {ca[q=24]=1;}  /* 1 */
  if (i >  0) {ca[q=25]=1;}  /* 0 */
  if (i <= 0) {ca[q=26]=1;}  /* 1 */
  if (i >= 0) {ca[q=27]=1;}  /* 0 */
  if (i == 0) {ca[q=28]=1;}  /* 0 */
  if (i != 0) {ca[q=29]=1;}  /* 1 */

  switch (i) {
    case 255: i='a';
              break;
    case 257: i='b';
              break;
    case 1024: i='c';
              break;
    default: i = 0;
  }

  while (1) ; /* always keep forever loop in main */

}

test2(u) int *u; {
  *u = 128;
}

test3 () {
  return 4;
}

/* end */
